@setlocal
@ECHO OFF
REM #5
REM parameters:
REM 1: Filename no extension
REM 2: -m32|-m64
REM 3: dll or lib Debug or Release defaults to MD
REM   MT   release use static mfc library
REM   MD   release use mfc dll library
REM   MTD  debug use mfc static library
REM   MDD  debug use dll mfc library

REM get just file name. RadAsm3 passes complete path with non project files
REM Note: because FN is set using %F% with quotes no need for quoted %FN%
REM ----------------------------
 SET F=%~nx1
REM ----------------------------
IF NOT EXIST "%F%.cpp" GOTO usage
SET FN="%F%.cpp"

IF [%2]==[] GOTO usage




IF [%3]==[] (
  SET BUILD=/D_AFXDLL /MD 
GOTO gotbuild
)

IF /I [%3] == [MTD] (
  SET BUILD=/MTd 
  GOTO gotbuild
)

IF /I [%3] == [MT] (
  SET BUILD=/MT 
  GOTO gotbuild
)

IF /I [%3] == [MD] (
  SET BUILD=/D_AFXDLL /MD 
  GOTO gotbuild
)

IF /I [%3] == [MDD] (
  SET BUILD=/D_AFXDLL /MDd
  GOTO gotbuild
)

GOTO usage

:gotbuild

SET STARTUP=/ENTRY:"wWinMainCRTStartup"

IF /I [%2] == [-m32] (
  SET XTYPE=x86
  SET BITS=32
  GOTO gotit
)
IF /I [%2] == [-m64] (
  SET XTYPE=x86_amd64
  SET BITS=64
)

:gotit

REM do the setup for paths and 32/64
CALL "%VS120COMNTOOLS%..\..\VC\vcvarsall.bat" %XTYPE%


SET SUBSYS=/SUBSYSTEM:WINDOWS
SET FTYPE="Windows MFC App"



REM --------------------------------------------------------------
REM always use the %F%.rc file in the Res Directory if it exists
REM this should handle both projects and individual files with resources
IF EXIST "%F%__.rc" (
  IF EXIST "%F%.rc" DEL "%F%.rc"
  REN "%F%__.rc" "%F%.rc"
)

IF EXIST "res\%F%.rc" (
  ECHO Compiling resources.....
  cd res
  Rc "%F%"
  SET VRES="res\%F%.res"
  cd ..
) ELSE (
  IF EXIST "%F%.rc" (
    ECHO Compiling resources.....
    Rc "%F%"
    SET VRES="%F%.res"
  )
)
IF NOT DEFINED WIN_VER SET WIN_VER=-DWINVER=0x601
ECHO -----------------------------------------------------------------------------
ECHO Compiling %FN% To a %BITS% bit %FTYPE%
ECHO -----------------------------------------------------------------------------
cl.exe  /O1 /Gd /W1 /EHsc %BUILD%  %FN% /Fe"%F%.EXE" %WIN_VER% %VRES%  /link %STARTUP% %4 %5 %6 %7 %8

:cleanup
ECHO Finished!

IF EXIST "%F%.obj" del "%F%.obj"
IF EXIST "%F%.res" del "%F%.res"
GOTO done
:usage
ECHO **************************************************************
ECHO  Usage:  VS12MFC.BAT MainFile  [-m32 or -m64]  [MT MTd MD MDd] extra files
ECHO   MT For release version using MFC static library 
ECHO   MTd For debug version using static library 
ECHO   MD For release version using MFC Dll library 
ECHO   MDd For debug version using MFC Dll library 
ECHO   defaults to MD
ECHO  Note:   ExtraFiles can be .libs, .res , .obj
ECHO **************************************************************
:done
endlocal
